<template lang="html">
  <div class="partner-message">
    <span class="title" v-if="title">{{ title }}</span>
    <p v-if="message" v-html="message"></p>
    <butter-input ref="form" v-if="form.length" v-for="(item, i) in form" :key="i" v-bind="item" :model="item.value" :validated="validated" @validate="validate" @input="updateForm(item, $event)" @browser-url="handler({ type: 'browser-url', url: $event })">
      <slot name="input" @input="updateForm(item, $event)"></slot>
    </butter-input>
    <span class="limit" v-if="limit">
      <butter-button @click.self="handler(actions[0])">{{ limitLabel }} <butter-currency v-if="limit" :value="limit" :trim="true" /></butter-button>
    </span>
    <div class="actions" v-else-if="actions.length">
      <butter-button v-if="expires && expired" @click.self="handler({ type: 'refresh' })"> Refresh Quote</butter-button>
      <butter-button v-else v-for="(action, i) in actions" :key="i" :secondary="action.style=='secondary'" :disabled="handling || (action.require && !action.validated)" @click.self="handler(action)">{{ action.title }}</butter-button>
    </div>
  </div>
</template>

<script>
import { EVENT_CLICK } from '../lib/events'

function castStringToBoolean(value) {
  if (value === "true") return true;
  if (value === "false") return false;
  return value;
}

export default {
  props: {
    'title': {
      type: String,
    },
    'message': {
      type: String,
    },
    'form': {
      type: Array,
      default: _ => ([]),
    },
    'userActions': {
      type: Array,
      default: _ => ([]),
    },
    'screenType': {
      type: String,
    },
    'partner': {
      type: String,
    },
    'country': {
      type: String,
    },
    'state': {
      type: String,
    },
    'limit': {
      type: Object,
    },
    'limitLabel': {
      type: String,
      default: "Set amount to"
    },
    'expires': {
      type: String,
    },
    'handling': {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      validated: false,
      actions: this.userActions,
      formResponse: [ ...this.form],
      now: new Date(),
      handlerIgnore: false,
      handlerIgnoreTimer: null,
    };
  },
  mounted() {
    if (this.actions) this.actions = this.actions.map(this.validateAction);
    this.__now_interval = setInterval(() => { this.now = new Date(); }, 100);
  },
  beforeDestroy() {
    clearInterval(this.__now_interval);
  },
  computed: {
    validationRequired() {
      return this.form.find(i => i.verify) || false;
    },
    serializedForm() {
      return this.formResponse.reduce((form, input) => {
        if(!input.name) return form;
        if(!form[input.name]) form[input.name] = input.value;
        return form;
      }, {});
    },
    expired() {
      if(!this.expires) return;
      const expire = new Date(this.expires);
      return expire < this.now;
    },
  },
  methods: {
    handler(action) {
      // Ignore double taps
      if (this.handlerIgnore) {
        return;
      } else {
        this.handlerIgnore = true;
        this.handlerIgnoreTimer = setTimeout(function() { this.handlerIgnore = false; }.bind(this), 3000);
      }
      const params = { ...action.params, ...this.serializedForm };
      this.$emit('action', { action: { ...action, params }, partner: this.partner })
    },
    inputValue(name) {
      const input = this.formResponse.find(input => input.name === name);
      return input && input.value;
    },
    requiredInput(inputs=[]) {
      if(!inputs.length) false;
      return inputs.some(name => !castStringToBoolean(this.inputValue(name)));
      return true;
    },
    validate(hash) {
      this.$emit('validate', { ...hash, context: this });
    },
    validateAction(action) {
      let validated;
      if (action.require && action.require.length) {
        validated = !this.requiredInput(action.require);
      }
      return {
        ...action,
        validated,
      };
    },
    updateForm({ name, type }, value) {
      /*
        Called on form input,
        updates form and validates actions
       */
      const input = this.formResponse && this.formResponse.find(input => input.name === name);
      if (input) input.value = value;
      if (!input) this.formResponse = [ ...this.formResponse, { name, value } ];
      if (this.actions) this.actions = this.actions.map(this.validateAction);
      return value;

    },
  },
  watch: {
    userActions(value) {
      this.actions = value;
    },
    state(value) {
      this.updateForm({ name: 'state', type: 'state' }, value);
    },
    country(value) {
      this.updateForm({ name: 'country', type: 'country' }, value);
    },
  }
}
</script>

<style lang="scss" scoped>
@import 'butter-themes';
@import 'butter-mixins';

  .partner-message {
    // Mixins
    // Box properties
    width: 100%;
    // Background & borders
    // Typography
    // Animation
    // Other
  }

  .title {
    @include themify($themes) {
      border-top: 1px solid themed('border-color');
    }
  }

  .title, .limit {
    // Mixins
    @include box-sizing;
    // Box properties
    margin: 0 0;
    padding: $grid * 2;
    display: inline-block;
    width: 100%;
    // Typography
    font-family: $font-sans-bold;
    // Animation
    // Other
  }

  .actions {
    display: flex;
    flex-direction: column;

    > div {
      padding-top: $grid;
    }
    > div:first-child {
      padding-top: 0;
    }
  }

  .limit, .actions {
    padding: $grid * 2;

    text-align: center;
    border-top: 0;
  }

  .partner-message > p {
    @include themify($themes) {
      color: themed('color-text-tertiary');
    }
    // Mixins
    // Box properties
    margin: 0 $grid * 2 $grid * 2;
    // Background & borders
    // Typography
    // Animation
    // Other
  }

  .primary-action {
    // Mixins
    // Box properties
    margin: $grid * 2 $grid * 2 $grid * 2;
    // Background & borders
    // Typography
    // Animation
    // Other
  }
</style>
